/* A Bison parser, made from parser.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

#define YYLSP_NEEDED 1

# define	INT	257
# define	FLOAT	258
# define	ID	259
# define	STRING	260
# define	TYVAR	261
# define	CHAR	262
# define	KW_INT	263
# define	KW_RETURN	264
# define	KW_VOID	265
# define	KW_SKIP	266
# define	KW_BOOL	267
# define	KW_FLOAT	268
# define	KW_IN	269
# define	KW_EXTERN_C	270
# define	KW_STRING	271
# define	KW_FUN	272
# define	KW_IF	273
# define	KW_ELSE	274
# define	KW_WHILE	275
# define	KW_DO	276
# define	KW_FOR	277
# define	KW_CASE	278
# define	KW_SWITCH	279
# define	KW_LET	280
# define	KW_EXPORT_AS	281
# define	KW_STRUCT	282
# define	KW_OPT_STRUCT	283
# define	KW_UNION	284
# define	KW_TYPE	285
# define	KW_TYPEDEF	286
# define	KW_TRUE	287
# define	KW_FALSE	288
# define	KW_OPEN	289
# define	KW_NULL	290
# define	KW_RAISE	291
# define	KW_TRY	292
# define	KW_EXCEPTION	293
# define	KW_BREAK	294
# define	KW_CONTINUE	295
# define	KW_FINALLY	296
# define	KW_WITH	297
# define	KW_SECTION	298
# define	DOUBLECOLON	299
# define	ARROW	300
# define	GE	301
# define	LE	302
# define	EQ	303
# define	NE	304
# define	LTLT	305
# define	GTGT	306
# define	PLUS_PLUS	307
# define	MINUS_MINUS	308
# define	SLASH_EQUAL	309
# define	PLUS_EQUAL	310
# define	MINUS_EQUAL	311
# define	PERCENT_EQUAL	312
# define	STAR_EQUAL	313
# define	AND_AND	314
# define	OR_OR	315
# define	UMINUS	316
# define	APPLICATION	317

#line 13 "parser.y"


#include "parser.h"
#include "support.h"

#include <gont/runtime.h>
#include "cgont/ast.h"
#include "cgont/cast.h"
#include "cgont/list.h"
#include "cgont/std.h"

#define YYPARSE_PARAM parm
#define YYLEX_PARAM parm
#define YYERROR_VERBOSE 1

#define YYDEBUG 1

/* Constants. */
static struct gont_union *none;
static struct gont_union *nil;
static struct gont_string *empty_string;

/* Used by impl: rule and parse routine. */
static struct gont_union *decls;

/* Defined in support.c. */
extern struct gont_string *input_filename;
struct GontS_Ast__location *make_location(YYLTYPE *l);
void yyerror(const char *msg);

extern YYLTYPE last_lex_loc;

#define make_expr(raw, l) Cast$$make_expr(raw, make_location(l))
#define make_tyvar Cast$$make_tyvar
#define make_located(d, l) Cast$$make_located(d, make_location(l))
#define make_ref_record(x) Cast$$make_ref_record(x)
#define make_vardef(t, n) Cast$$make_vardef(t, n)
#define make_field(t, n) Cast$$make_field(t, n, make_location(&yyloc))
#define make_tydef(name, vars, ty) \
	Cast$$make_tydef(name, vars, ty, make_location(&yyloc))
#define make_fn_decl(header, exportas, body) \
	Cast$$make_fn_decl(header, exportas, body)
#define bare_fn_type(r, a) Cast$$bare_fn_type(r, a)
#define make_vardefs(t, vars) Cast$$make_vardefs(t, vars)
#define make_lambda Cast$$make_lambda
#define make_lambda_assign Cast$$make_lambda_assign
#define make_break Cast$$make_break
#define make_loop Cast$$make_loop
#define make_namedexpr Cast$$make_namedexpr
#define make_sini_expr Cast$$make_sini_expr
#define make_named_type Cast$$make_named_type
#define make_try_record Cast$$make_try_record
#define make_float_const Cast$$make_float_const
#define make_int_const Cast$$make_int_const
#define make_char_const Cast$$make_char_const
#define make_named_pattern Cast$$make_named_pattern
#define make_section_record Cast$$make_section_record
#define make_case_clause Cast$$make_case_clause

#define WEAK() Cast$$make_weak_type()

#define U(fld, val) \
	gont_make_union(GontUF_Ast__ ## fld, (val))

#define Some(x) \
	gont_make_union(GontUF_Std__Some, (x))

#define P(a, b) \
	gont_make_tuple(2, (a), (b))

#define TRIPLE(a, b, c) \
	gont_make_tuple(3, (a), (b), (c))

#define CONS(a, b) \
	gont_make_union(GontUF_List__Cons, P((a), (b)))

#define EXPR(fld, val) \
	make_expr(U(fld, (val)), &yyloc)

#define BIN(op, e1, e2) \
	EXPR(SimpleBinOp, TRIPLE(U(op, NULL), (e1), (e2)))

#define UNARY(op, e) \
	EXPR(SimpleUnOp, P(U(op, none), e))

#define LOCATED(x) \
	make_located(x, &yyloc)

#define STMT(fld, val) \
	LOCATED(U(fld, (val)))

#define PAIR(a, b) \
	STMT(Pair, P((a), (b)))

#define SKIP() \
	STMT(Skip, NULL)

#define LOOP(lab, body, inc) \
	LOCATED(make_loop(lab, body, inc))
#ifndef YYSTYPE
# define YYSTYPE int
# define YYSTYPE_IS_TRIVIAL 1
#endif

#ifndef YYLTYPE
typedef struct yyltype
{
  int first_line;
  int first_column;

  int last_line;
  int last_column;
} yyltype;

# define YYLTYPE yyltype
# define YYLTYPE_IS_TRIVIAL 1
#endif

#ifndef YYDEBUG
# define YYDEBUG 1
#endif



#define	YYFINAL		433
#define	YYFLAG		-32768
#define	YYNTBASE	85

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 317 ? yytranslate[x] : 172)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    72,     2,     2,     2,    69,     2,     2,
      79,    80,    68,    65,    76,    66,    74,    70,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    84,    75,
      63,    62,    64,     2,    67,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    81,     2,    82,     2,    83,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    77,     2,    78,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    71,    73
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     1,     4,     6,     8,    10,    12,    14,    16,
      18,    20,    22,    24,    26,    29,    32,    35,    37,    40,
      41,    44,    48,    52,    56,    60,    63,    65,    67,    71,
      74,    76,    80,    81,    84,    88,    89,    92,    96,    98,
     101,   108,   115,   122,   127,   131,   133,   135,   137,   139,
     141,   147,   155,   159,   161,   165,   166,   168,   170,   172,
     174,   179,   186,   195,   200,   204,   206,   208,   210,   213,
     215,   218,   220,   224,   225,   227,   233,   239,   242,   247,
     249,   251,   253,   257,   258,   260,   262,   266,   267,   269,
     271,   275,   279,   283,   285,   289,   292,   295,   298,   301,
     303,   307,   311,   315,   319,   323,   327,   331,   335,   339,
     343,   347,   350,   354,   359,   362,   364,   367,   371,   375,
     379,   383,   387,   391,   395,   399,   403,   407,   411,   415,
     419,   422,   424,   426,   428,   430,   432,   434,   436,   438,
     440,   442,   444,   448,   450,   452,   456,   460,   462,   466,
     472,   477,   484,   491,   497,   501,   503,   506,   507,   509,
     512,   514,   516,   518,   520,   522,   524,   526,   528,   530,
     536,   544,   552,   554,   558,   560,   564,   567,   570,   572,
     574,   576,   577,   579,   580,   582,   584,   585,   586,   589,
     590,   592,   599,   608,   619,   621,   623,   626,   628,   630,
     633,   636,   639,   641,   645,   649,   655,   657,   660,   663,
     666,   667,   671,   673,   677,   680,   681,   686,   687,   692,
     697,   703,   707,   709,   710,   712,   716,   718,   720,   722,
     724,   727
};
static const short yyrhs[] =
{
      -1,    86,    85,     0,    87,     0,    94,     0,    90,     0,
      96,     0,   106,     0,    91,     0,   118,     0,    89,     0,
      88,     0,    95,     0,    75,     0,    35,     5,     0,   100,
      75,     0,    39,   100,     0,     6,     0,     6,    92,     0,
       0,    27,    92,     0,   117,    93,   155,     0,    44,     5,
     155,     0,    16,   117,    75,     0,    16,   100,    75,     0,
     117,   155,     0,     5,     0,    98,     0,     5,    45,     5,
       0,   113,    98,     0,     7,     0,     7,    76,   101,     0,
       0,    63,    64,     0,    63,   101,    64,     0,     0,   103,
      75,     0,   113,    99,   103,     0,   104,     0,   104,   105,
       0,    28,   102,     5,    77,   105,    78,     0,    29,   102,
       5,    77,   105,    78,     0,    30,   102,     5,    77,   105,
      78,     0,    32,   113,   102,     5,     0,    31,   102,     5,
       0,    11,     0,     9,     0,    13,     0,    14,     0,    17,
       0,    68,   113,    79,   116,    80,     0,    68,    79,   113,
      79,   116,    80,    80,     0,   113,    76,   110,     0,   113,
       0,   113,    76,   110,     0,     0,   110,     0,   107,     0,
     108,     0,     7,     0,    63,   111,    64,    99,     0,    51,
     110,    64,    99,    64,    99,     0,    51,   110,    64,    99,
      76,   110,    64,    99,     0,    68,    81,   109,    82,     0,
      79,   112,    80,     0,    99,     0,   112,     0,   113,     0,
     113,     5,     0,    83,     0,    83,     5,     0,   114,     0,
     114,    76,   115,     0,     0,   115,     0,   113,    98,    79,
     116,    80,     0,    83,    98,    79,   116,    80,     0,   117,
      75,     0,   117,    62,    92,    75,     0,     5,     0,    12,
       0,   119,     0,   119,    76,   120,     0,     0,   120,     0,
     130,     0,   130,    76,   122,     0,     0,   122,     0,    99,
       0,   130,    76,   130,     0,   130,    76,   125,     0,    81,
     125,    82,     0,   135,     0,   130,    62,   130,     0,    54,
     130,     0,    53,   130,     0,   130,    54,     0,   130,    53,
       0,   131,     0,   128,    65,   128,     0,   128,    66,   128,
       0,   128,    68,   128,     0,   128,    70,   128,     0,   128,
      69,   128,     0,   128,    63,   128,     0,   128,    64,   128,
       0,   128,    47,   128,     0,   128,    48,   128,     0,   128,
      49,   128,     0,   128,    50,   128,     0,    66,   128,     0,
      99,    81,    82,     0,    99,    81,   130,    82,     0,    99,
     126,     0,   131,     0,    72,   130,     0,   130,    65,   130,
       0,   130,    66,   130,     0,   130,    68,   130,     0,   130,
      70,   130,     0,   130,    69,   130,     0,   130,    63,   130,
       0,   130,    64,   130,     0,   130,    47,   130,     0,   130,
      48,   130,     0,   130,    49,   130,     0,   130,    50,   130,
       0,   130,    60,   130,     0,   130,    61,   130,     0,    66,
     130,     0,   126,     0,   127,     0,   134,     0,   129,     0,
       3,     0,     4,     0,     8,     0,    92,     0,    33,     0,
      34,     0,   124,     0,    79,   130,    80,     0,   136,     0,
      36,     0,   131,    74,    98,     0,    99,    62,   130,     0,
     132,     0,   132,    76,   133,     0,    79,    77,   133,    78,
      80,     0,   131,    79,   123,    80,     0,    18,   113,    79,
     116,    80,   155,     0,    18,    83,    79,   116,    80,   155,
       0,    18,    79,   121,    80,   155,     0,    77,   139,    78,
       0,   142,     0,   142,   138,     0,     0,   138,     0,   154,
      75,     0,   137,     0,    97,     0,   153,     0,   165,     0,
     164,     0,   143,     0,   140,     0,   141,     0,   144,     0,
      19,    79,   130,    80,   141,     0,    19,    79,   130,    80,
     144,    20,   142,     0,    19,    79,   130,    80,   140,    20,
     142,     0,    98,     0,    98,    62,   130,     0,   145,     0,
     145,    76,   146,     0,   113,   146,     0,    83,   146,     0,
     127,     0,   147,     0,    12,     0,     0,   130,     0,     0,
     127,     0,    12,     0,     0,     0,     5,    84,     0,     0,
      98,     0,   151,    21,    79,   130,    80,   142,     0,   151,
      22,   137,    21,    79,   130,    80,    75,     0,   151,    23,
      79,   148,    75,   149,    75,   150,    80,   142,     0,   127,
       0,    10,     0,    10,   130,     0,    12,     0,   147,     0,
      37,   130,     0,    40,   152,     0,    41,   152,     0,   137,
       0,    79,   130,    80,     0,    24,   171,    84,     0,    24,
     171,    19,   130,    84,     0,   156,     0,   156,   157,     0,
     157,   138,     0,   158,   159,     0,     0,   171,    62,   130,
       0,   160,     0,   160,    76,   161,     0,    42,   142,     0,
       0,    43,    77,   159,    78,     0,     0,    38,   137,   163,
     162,     0,    26,   161,    15,   142,     0,    25,   130,    77,
     159,    78,     0,   171,    76,   166,     0,   171,     0,     0,
     166,     0,    81,   167,    82,     0,   168,     0,    83,     0,
     128,     0,   168,     0,    99,   169,     0,   170,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   160,   162,   165,   169,   171,   172,   173,   174,   175,
     176,   177,   178,   185,   189,   193,   197,   201,   203,   206,
     208,   211,   217,   224,   226,   229,   237,   241,   243,   246,
     254,   256,   259,   261,   262,   265,   267,   270,   274,   276,
     279,   282,   284,   286,   288,   292,   294,   295,   296,   297,
     300,   303,   307,   311,   313,   316,   318,   321,   323,   324,
     325,   327,   329,   331,   334,   336,   337,   344,   346,   347,
     348,   351,   353,   356,   358,   361,   364,   368,   370,   374,
     376,   379,   381,   384,   386,   392,   394,   397,   399,   402,
     406,   408,   411,   416,   418,   419,   420,   421,   422,   425,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   441,   445,   447,   451,   455,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   477,   480,   482,   484,   485,
     486,   487,   488,   489,   490,   491,   495,   500,   502,   505,
     510,   515,   518,   520,   527,   531,   533,   536,   538,   541,
     543,   544,   545,   546,   547,   550,   550,   551,   551,   553,
     558,   561,   565,   567,   574,   576,   579,   581,   585,   587,
     588,   589,   593,   595,   599,   601,   602,   606,   608,   611,
     613,   616,   621,   625,   636,   638,   639,   640,   641,   642,
     643,   645,   649,   651,   658,   661,   665,   667,   670,   674,
     676,   679,   683,   685,   688,   690,   693,   695,   698,   703,
     706,   714,   716,   719,   721,   724,   728,   732,   734,   735,
     736,   740
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "INT", "FLOAT", "ID", "STRING", "TYVAR", 
  "CHAR", "KW_INT", "KW_RETURN", "KW_VOID", "KW_SKIP", "KW_BOOL", 
  "KW_FLOAT", "KW_IN", "KW_EXTERN_C", "KW_STRING", "KW_FUN", "KW_IF", 
  "KW_ELSE", "KW_WHILE", "KW_DO", "KW_FOR", "KW_CASE", "KW_SWITCH", 
  "KW_LET", "KW_EXPORT_AS", "KW_STRUCT", "KW_OPT_STRUCT", "KW_UNION", 
  "KW_TYPE", "KW_TYPEDEF", "KW_TRUE", "KW_FALSE", "KW_OPEN", "KW_NULL", 
  "KW_RAISE", "KW_TRY", "KW_EXCEPTION", "KW_BREAK", "KW_CONTINUE", 
  "KW_FINALLY", "KW_WITH", "KW_SECTION", "DOUBLECOLON", "ARROW", "GE", 
  "LE", "EQ", "NE", "LTLT", "GTGT", "PLUS_PLUS", "MINUS_MINUS", 
  "SLASH_EQUAL", "PLUS_EQUAL", "MINUS_EQUAL", "PERCENT_EQUAL", 
  "STAR_EQUAL", "AND_AND", "OR_OR", "'='", "'<'", "'>'", "'+'", "'-'", 
  "'@'", "'*'", "'%'", "'/'", "UMINUS", "'!'", "APPLICATION", "'.'", 
  "';'", "','", "'{'", "'}'", "'('", "')'", "'['", "']'", "'_'", "':'", 
  "module", "decl", "nl_decl", "dummy_decl", "top_open", "global_var", 
  "exn_decl", "string", "maybe_export_as", "func", "section", "extern_c", 
  "func_def", "id", "qid", "vardef", "type_var_list_content", 
  "type_var_list", "maybe_semicolons", "record_type_fld", 
  "record_type_flds", "type_decl", "simple_type", "function_type", 
  "tuple_ty", "ne_ty_list", "ty_list", "xtype_exp", "type_exp", 
  "func_arg", "ne_func_args", "func_args", "func_header", "func_proto", 
  "xt_arg", "ne_xt_args", "xt_args", "ne_expr_list", "expr_list", 
  "variable", "tuple_content", "tuple", "stmt_expr", "pattern_expr", 
  "union_expr", "expr", "primary", "struct_init", "struct_expr_content", 
  "struct_expr", "call", "lambda", "block", "ne_stmts", "stmts", 
  "non_if_stmt", "no_else", "stmt", "if_stmt", "if_else_stmt", 
  "single_var_def", "var_def_list", "var_def", "for_exp1", "for_exp2", 
  "for_exp3", "maybe_label", "maybe_id", "loop_stmt", "normal_stmt", 
  "fnc_body", "one_case", "cases", "case_clause", "case_list", 
  "pattern_eq", "pattern_eq_list", "maybe_finally", "maybe_with", 
  "try_stmt", "pattern_matching_stmt", "ne_pattern_list", "pattern_list", 
  "raw_tuple_pattern", "tuple_pattern", "raw_pattern", "pattern", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    85,    85,    86,    87,    87,    87,    87,    87,    87,
      87,    87,    87,    88,    89,    90,    91,    92,    92,    93,
      93,    94,    95,    96,    96,    97,    98,    99,    99,   100,
     101,   101,   102,   102,   102,   103,   103,   104,   105,   105,
     106,   106,   106,   106,   106,   107,   107,   107,   107,   107,
     108,   108,   109,   110,   110,   111,   111,   112,   112,   112,
     112,   112,   112,   112,   113,   113,   113,   114,   114,   114,
     114,   115,   115,   116,   116,   117,   117,   118,   118,   119,
     119,   120,   120,   121,   121,   122,   122,   123,   123,   124,
     125,   125,   126,   127,   127,   127,   127,   127,   127,   128,
     128,   128,   128,   128,   128,   128,   128,   128,   128,   128,
     128,   128,   129,   129,   129,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   131,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   131,   132,   133,   133,   134,
     135,   136,   136,   136,   137,   138,   138,   139,   139,   140,
     140,   140,   140,   140,   140,   141,   141,   142,   142,   143,
     144,   144,   145,   145,   146,   146,   147,   147,   148,   148,
     148,   148,   149,   149,   150,   150,   150,   151,   151,   152,
     152,   153,   153,   153,   154,   154,   154,   154,   154,   154,
     154,   154,   155,   155,   156,   156,   157,   157,   158,   159,
     159,   160,   161,   161,   162,   162,   163,   163,   164,   165,
     165,   166,   166,   167,   167,   168,   169,   170,   170,   170,
     170,   171
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     0,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     1,     2,     0,
       2,     3,     3,     3,     3,     2,     1,     1,     3,     2,
       1,     3,     0,     2,     3,     0,     2,     3,     1,     2,
       6,     6,     6,     4,     3,     1,     1,     1,     1,     1,
       5,     7,     3,     1,     3,     0,     1,     1,     1,     1,
       4,     6,     8,     4,     3,     1,     1,     1,     2,     1,
       2,     1,     3,     0,     1,     5,     5,     2,     4,     1,
       1,     1,     3,     0,     1,     1,     3,     0,     1,     1,
       3,     3,     3,     1,     3,     2,     2,     2,     2,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     3,     4,     2,     1,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     3,     3,     1,     3,     5,
       4,     6,     6,     5,     3,     1,     2,     0,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     5,
       7,     7,     1,     3,     1,     3,     2,     2,     1,     1,
       1,     0,     1,     0,     1,     1,     0,     0,     2,     0,
       1,     6,     8,    10,     1,     1,     2,     1,     1,     2,
       2,     2,     1,     3,     3,     5,     1,     2,     2,     2,
       0,     3,     1,     3,     2,     0,     4,     0,     4,     4,
       5,     3,     1,     0,     1,     3,     1,     1,     1,     1,
       2,     1
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       1,    26,    59,    46,    45,    47,    48,     0,    49,    32,
      32,    32,    32,     0,     0,     0,     0,     0,    55,     0,
      13,     0,     0,     1,     3,    11,    10,     5,     8,     4,
      12,     6,    27,    65,     0,     7,    57,    58,    66,     0,
      19,     9,     0,     0,     0,     0,     0,     0,     0,     0,
      32,    14,    16,     0,     0,     0,    53,    56,     0,     0,
       0,     0,     0,    26,     0,     2,    15,    29,     0,     0,
      77,     0,    28,    24,    23,    30,    33,     0,     0,     0,
       0,    44,     0,    29,   187,     0,   202,    22,     0,     0,
       0,    66,     0,     0,     0,    73,    64,    73,    73,    17,
      20,     0,    21,     0,    34,     0,     0,     0,    43,   135,
     136,    26,   137,   195,   197,     0,     0,     0,     0,   139,
     140,   144,     0,     0,   189,   189,     0,     0,     0,     0,
       0,     0,     0,   138,   161,    89,     0,     0,   141,   131,
     132,   134,     0,   115,   133,    93,   143,   160,   158,     0,
     166,   167,   187,   165,   168,   198,     0,   162,     0,   164,
     163,     0,    89,   132,     0,     0,    54,    60,    73,    63,
       0,    69,    67,    71,    74,     0,     0,     0,    18,    78,
      31,    38,     0,     0,     0,     0,   188,   196,    83,     0,
       0,     0,     0,     0,     0,   223,   227,    89,   228,    99,
     212,     0,   229,   231,     0,   199,   217,   190,   200,   201,
      96,    95,   130,   116,     0,     0,     0,     0,   172,   174,
     177,     0,   114,   172,   176,    25,     0,     0,     0,     0,
      98,    97,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    87,   154,   156,     0,     0,     0,   159,
     203,     0,     0,     0,    52,    70,    68,     0,    50,    76,
      75,    39,    40,    35,    41,    42,    79,    80,    81,    84,
       0,    73,    73,     0,   210,    89,   111,   224,     0,   222,
     226,   230,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   187,     0,     0,   215,     0,   147,
       0,   142,    92,     0,     0,     0,   112,     0,   124,   125,
     126,   127,   128,   129,    94,   122,   123,   117,   118,   119,
     121,   120,   145,    88,     0,    85,     0,     0,   181,    61,
       0,     0,    72,    37,     0,     0,     0,     0,   187,     0,
     206,   187,   210,     0,   225,     0,   107,   108,   109,   110,
     105,   106,   100,   101,   102,   104,   103,   213,   219,   211,
     210,   187,   218,     0,     0,     0,    91,    90,   173,   172,
     175,   113,   150,     0,     0,     0,   180,     0,     0,   132,
     179,     0,     0,    51,    36,    82,   153,     0,     0,   166,
     169,     0,     0,   207,   208,   209,   220,   221,     0,   214,
     146,   148,   149,    86,   187,     0,   183,    62,   152,   151,
     187,   187,     0,   204,   216,   191,     0,   182,     0,   171,
     170,     0,     0,   186,   205,   192,   185,   132,     0,   187,
     193,     0,     0,     0
};

static const short yydefgoto[] =
{
      65,    23,    24,    25,    26,    27,    28,   133,    71,    29,
      30,    31,   134,    32,   162,    34,    77,    46,   333,   181,
     182,    35,    36,    37,    93,    55,    58,    38,   136,   173,
     174,   175,   137,    41,   268,   269,   270,   323,   324,   138,
     216,   139,   163,   198,   141,   142,   143,   299,   300,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     219,   220,   155,   381,   418,   428,   156,   208,   157,   158,
      87,   340,   341,   342,   343,   200,   201,   362,   297,   159,
     160,   277,   278,   202,   281,   203,   204
};

static const short yypact[] =
{
     904,    -3,-32768,-32768,-32768,-32768,-32768,   811,-32768,    -5,
      -5,    -5,    -5,  1066,    59,  1066,    63,  1066,  1066,  1018,
  -32768,   550,    73,   904,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,     4,-32768,-32768,-32768,-32768,    73,
     -21,-32768,    77,    25,    26,    13,    97,    98,    99,   106,
      -5,-32768,-32768,    73,    17,    48,    37,-32768,    50,  1066,
    1066,    40,    42,-32768,    46,-32768,-32768,    51,   121,   121,
  -32768,    17,-32768,-32768,-32768,    53,-32768,    70,    58,    65,
      66,-32768,   140,-32768,   570,   985,-32768,-32768,   142,  1066,
     142,    42,    76,    74,    82,   947,-32768,   947,   947,   121,
  -32768,    87,-32768,   156,-32768,  1066,  1066,  1066,-32768,-32768,
  -32768,   -23,-32768,   985,-32768,   995,    85,   985,   691,-32768,
  -32768,-32768,   985,    88,    73,    73,   985,   985,   985,   985,
     835,   985,    73,-32768,-32768,    -1,    73,    17,-32768,-32768,
      91,-32768,  1295,   -36,-32768,-32768,-32768,-32768,-32768,    89,
  -32768,-32768,   475,-32768,-32768,-32768,    64,-32768,    94,-32768,
  -32768,   827,    93,-32768,  1102,   -25,-32768,-32768,   947,-32768,
    1066,   173,   175,   110,-32768,   102,   108,   109,-32768,-32768,
  -32768,  1066,   116,   142,   118,   132,-32768,  1295,   210,   130,
     133,   985,  1222,   329,   985,   691,-32768,   135,  1327,   113,
     137,   196,-32768,-32768,   163,  1295,   187,-32768,-32768,-32768,
      21,    21,    21,    21,   142,  1126,   136,  1247,   -30,   155,
  -32768,   755,-32768,   -16,-32768,-32768,   985,   985,   985,   985,
  -32768,-32768,   985,   985,   985,   985,   985,   985,   985,   985,
     985,   985,    73,   985,-32768,-32768,   153,    88,   161,-32768,
  -32768,   142,  1066,   162,-32768,-32768,-32768,   947,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   159,-32768,
     165,   947,   947,  1150,   217,-32768,-32768,-32768,   167,   174,
  -32768,-32768,   329,   329,   329,   329,   329,   329,   329,   329,
     329,   329,   329,   691,   651,   985,   166,   211,   193,   180,
     181,-32768,-32768,   985,   985,    73,-32768,  1078,   254,   254,
     107,   107,  1319,  1319,  1295,   254,   254,     2,     2,    21,
      21,    21,-32768,-32768,   178,  1271,   985,   248,   732,-32768,
     206,   194,-32768,   200,    57,    17,   197,   199,   651,   691,
     217,   651,   217,   202,-32768,   691,   198,   198,    71,    71,
     198,   198,    23,    23,-32768,-32768,-32768,-32768,-32768,  1295,
     217,   651,-32768,   985,   142,   201,-32768,  1247,  1295,   214,
  -32768,-32768,-32768,   985,  1174,   216,-32768,    73,    73,   223,
  -32768,   225,   142,-32768,-32768,-32768,-32768,    17,    17,   282,
  -32768,   285,   -11,-32768,-32768,-32768,-32768,-32768,   232,-32768,
    1295,-32768,-32768,-32768,   651,   985,   985,-32768,-32768,-32768,
     651,   651,   985,-32768,-32768,-32768,  1198,  1295,   236,-32768,
  -32768,  1040,   238,   941,-32768,-32768,-32768,   235,   245,   651,
  -32768,   316,   326,-32768
};

static const short yypgoto[] =
{
     327,-32768,-32768,-32768,-32768,-32768,-32768,   -34,-32768,-32768,
  -32768,-32768,-32768,    -8,     0,    29,   227,    16,-32768,-32768,
     -82,-32768,-32768,-32768,-32768,   -13,-32768,    -9,   131,-32768,
      79,   -87,    30,-32768,-32768,     6,-32768,   -42,-32768,-32768,
      41,  -114,   -32,   150,-32768,   229,   -85,-32768,   -15,-32768,
  -32768,-32768,   -14,  -149,-32768,    10,    12,  -278,-32768,    14,
  -32768,  -134,    38,-32768,-32768,-32768,-32768,   228,-32768,-32768,
     -70,-32768,    27,-32768,  -313,-32768,    61,-32768,-32768,-32768,
  -32768,    31,-32768,   171,-32768,-32768,  -186
};


#define	YYLAST		1397


static const short yytable[] =
{
      33,   102,   224,   245,   -65,    57,    68,    33,   412,   279,
     176,   177,    62,    33,    64,    33,   358,    33,    33,    33,
      75,   222,    42,    33,   184,   185,    47,    48,    49,   395,
      40,    67,   304,   199,   100,   101,    43,    44,   242,   251,
      86,    69,    42,   243,    52,    83,   304,   398,   222,    97,
      91,   252,   140,    40,    70,   230,   231,    86,    45,    33,
      33,   186,   266,    98,    51,   178,    82,   225,    54,   267,
     239,   240,   241,   413,   230,   231,   166,    76,    63,    66,
     221,   253,    72,   399,   135,   246,   247,   248,   165,    33,
     167,   290,   291,   292,    84,    33,    85,    33,    33,   261,
      73,    74,    78,    79,    80,    33,    33,    33,   199,   206,
     199,    81,    88,    89,    90,    33,   207,   207,   197,    95,
     140,    62,    96,    86,   218,    97,   415,    99,   223,   103,
      98,    39,   419,   420,   104,   105,   288,   289,    39,   290,
     291,   292,   106,   107,    50,   108,    53,     1,    56,    56,
      61,   430,   135,   392,    39,   168,   169,   254,   170,   279,
     230,   231,   179,    75,   191,    84,  -194,   244,    33,   249,
      33,   370,   237,   238,   221,   239,   240,   241,   255,    62,
     256,    33,   258,   263,   336,   337,   257,   242,   259,   260,
      92,    94,   394,   275,   262,   197,   264,   199,   199,   199,
     199,   199,   199,   199,   199,   199,   199,   199,   199,   271,
     265,   294,   272,   293,   298,   266,   195,     2,   302,     3,
      56,     4,   267,     5,     6,   295,   172,     8,   172,   172,
     296,   305,   326,   327,   322,   334,   183,   183,   183,   330,
     328,   339,   331,   360,   224,   335,   190,   284,   285,   344,
     345,   329,    33,   361,   199,   363,   364,    33,   372,   365,
     199,    17,   140,   288,   289,   386,   290,   291,   292,   375,
     382,    33,    33,    18,   383,   384,   304,   387,    19,   388,
     396,   402,   275,   275,   275,   275,   275,   275,   275,   275,
     275,   275,   275,   197,   135,   405,   379,   369,  -178,   172,
     406,    56,   410,   228,   229,   411,   140,   230,   231,   140,
     414,   423,   183,   425,   164,  -184,   432,   408,   409,   237,
     238,    86,   239,   240,   241,   429,   433,   431,   135,   140,
     180,   403,   109,   110,     1,    99,   332,   112,   135,   197,
     385,   135,   187,   276,   366,   197,   192,   115,   389,   401,
     390,   205,   391,   209,   357,   210,   211,   212,   213,   215,
     217,   135,   119,   120,   298,   121,   380,   393,   280,   369,
     369,     0,   140,    86,    86,     0,   397,     0,   140,   140,
       0,     0,   407,    56,     0,     0,     0,     0,   172,     0,
     215,   427,     0,     0,     0,   193,     0,   140,     0,     0,
       0,     0,   172,   172,   135,     0,     0,     0,   194,     0,
     135,   135,     0,     0,     0,     0,     0,     0,     0,     0,
     273,     0,     0,   215,     0,     0,     0,     0,     0,   135,
       0,     0,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,     0,     0,     0,     0,     0,     0,     0,
     307,     0,     0,     0,     0,   308,   309,   310,   311,   378,
       0,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,     0,   325,     0,     0,     0,     0,     0,   109,   110,
     111,    99,     2,   112,     3,   113,     4,   114,     5,     6,
       0,     0,     8,   115,   116,     0,     0,     0,     0,  -155,
     117,   118,     0,     0,     0,     0,     0,     0,   119,   120,
       0,   121,   122,   123,     0,   124,   125,     0,     0,     0,
       0,     0,     0,     0,   359,     0,    17,     0,   126,   127,
       0,     0,   367,   368,     0,     0,     0,     0,    18,     0,
       0,   128,     0,    19,     0,     0,     0,   129,     0,     0,
       0,     0,    84,  -155,   130,   374,   131,     2,   132,     3,
       0,     4,     0,     5,     6,     0,     0,     8,     0,     0,
       0,     0,     0,   109,   110,   111,    99,     2,   112,     3,
     113,     4,   114,     5,     6,     0,     0,     8,   115,   116,
       0,     0,   400,     0,     0,   117,   118,     0,     0,     0,
       0,    17,   325,   119,   120,     0,   121,   122,   123,     0,
     124,   125,     0,    18,     0,     0,     0,     0,    19,     0,
       0,    17,     0,   126,   127,     0,     0,     0,     0,     0,
       0,     0,     0,    18,   416,   417,   128,     0,    19,     0,
       0,   421,   129,     0,     0,     0,     0,    84,  -157,   130,
       0,   131,     0,   132,   109,   110,   111,    99,     2,   112,
       3,   113,     4,   114,     5,     6,     0,     0,     8,   115,
     116,     0,     0,     0,     0,     0,   117,   118,     0,     0,
       0,     0,     0,     0,   119,   120,     0,   121,   122,   123,
       0,   124,   125,     0,   109,   110,     1,    99,     0,   112,
       0,     0,    17,     0,   126,   127,     0,     0,     0,   115,
       0,     0,     0,     0,    18,     0,     0,   128,     0,    19,
       0,     0,     0,   129,   119,   120,     0,   121,    84,     0,
     130,     0,   131,     0,   132,   109,   110,     1,    99,     2,
     112,     3,     0,     4,   376,     5,     6,     0,     0,     8,
     115,     0,     0,     0,     0,     0,     0,   193,   109,   110,
       1,    99,     0,   112,     0,   119,   120,     0,   121,     0,
     194,     0,   195,   115,   196,     0,     0,     0,     0,     0,
       0,     0,     0,    17,     0,   126,   127,     0,   119,   120,
       0,   121,     0,     0,     0,    18,     0,     0,   128,     0,
      19,     0,     0,     0,   129,     0,     0,     0,   126,   127,
       0,   130,     0,   131,     0,   377,     1,     0,     2,     0,
       3,   128,     4,     0,     5,     6,     0,   129,     8,     0,
     109,   110,     1,    99,   161,   112,   131,   306,   109,   110,
       1,    99,     2,   112,     3,   115,     4,     0,     5,     6,
       0,     0,     8,   115,     0,     0,     0,     0,     0,     0,
     119,   120,    17,   121,     0,     0,     0,     0,   119,   120,
       0,   121,     0,     0,    18,     0,     0,     0,     0,    19,
     126,   127,     0,     0,     0,     0,    17,     0,   126,   127,
      21,     0,     0,   128,    22,     0,     0,     0,    18,   129,
       0,   128,     0,    19,   214,     0,   161,   129,   131,     1,
       0,     2,   214,     3,   161,     4,   131,     5,     6,     0,
       7,     8,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     9,    10,    11,    12,    13,     0,     0,    14,
       0,     0,     0,    15,   109,   110,     1,    99,    16,   112,
       0,     0,     1,   426,     2,    17,     3,     0,     4,   115,
       5,     6,     0,     0,     8,     0,     0,    18,     0,     0,
       0,     0,    19,     0,   119,   120,     0,   121,     0,    20,
       0,     0,     0,    21,     0,     0,     0,    22,   109,   110,
       1,    99,     0,   112,   126,   127,     0,     0,    17,     0,
       1,     0,     2,   115,     3,     0,     4,   128,     5,     6,
      18,     0,     8,   129,     0,    19,     0,     0,   119,   120,
     161,   121,   131,     1,     0,     2,    21,     3,     0,     4,
     171,     5,     6,     0,     0,     8,     0,     0,   126,   127,
       0,     0,     0,     0,     0,     0,    17,     0,     0,     0,
       0,   128,     0,     0,     0,     0,     0,   129,    18,     0,
       0,     0,     0,    19,   161,     0,   131,     0,     0,    17,
       0,     1,     0,     2,   188,     3,     0,     4,   189,     5,
       6,    18,     0,     8,     0,     0,    19,   226,   227,   228,
     229,     0,     0,   230,   231,     0,     0,    59,     0,    60,
     232,   233,   234,   235,   236,   237,   238,     0,   239,   240,
     241,     0,     0,     0,     0,     0,     0,    17,     0,     0,
       0,     0,     0,     0,   424,   226,   227,   228,   229,    18,
       0,   230,   231,     0,    19,     0,     0,     0,   232,   233,
     234,   235,   236,   237,   238,    21,   239,   240,   241,   226,
     227,   228,   229,     0,   303,   230,   231,     0,     0,     0,
     371,     0,   232,   233,   234,   235,   236,   237,   238,     0,
     239,   240,   241,   226,   227,   228,   229,     0,     0,   230,
     231,     0,   250,     0,     0,     0,   232,   233,   234,   235,
     236,   237,   238,     0,   239,   240,   241,   226,   227,   228,
     229,     0,     0,   230,   231,     0,   301,     0,     0,     0,
     232,   233,   234,   235,   236,   237,   238,     0,   239,   240,
     241,   226,   227,   228,   229,     0,     0,   230,   231,     0,
     338,     0,     0,     0,   232,   233,   234,   235,   236,   237,
     238,     0,   239,   240,   241,   226,   227,   228,   229,     0,
       0,   230,   231,     0,   404,     0,     0,     0,   232,   233,
     234,   235,   236,   237,   238,     0,   239,   240,   241,   226,
     227,   228,   229,     0,     0,   230,   231,     0,   422,     0,
       0,     0,   232,   233,   234,   235,   236,   237,   238,     0,
     239,   240,   241,     0,   226,   227,   228,   229,     0,   274,
     230,   231,     0,     0,     0,     0,     0,   232,   233,   234,
     235,   236,   237,   238,     0,   239,   240,   241,   226,   227,
     228,   229,     0,   303,   230,   231,     0,     0,     0,     0,
       0,   232,   233,   234,   235,   236,   237,   238,     0,   239,
     240,   241,   226,   227,   228,   229,     0,   373,   230,   231,
       0,     0,     0,     0,     0,   232,   233,   234,   235,   236,
     237,   238,     0,   239,   240,   241,   226,   227,   228,   229,
       0,     0,   230,   231,   282,   283,   284,   285,     0,     0,
       0,     0,   235,   236,   237,   238,     0,   239,   240,   241,
     286,   287,   288,   289,     0,   290,   291,   292
};

static const short yycheck[] =
{
       0,    71,   136,   152,     5,    18,    27,     7,    19,   195,
      97,    98,    21,    13,    22,    15,   294,    17,    18,    19,
       7,   135,    45,    23,   106,   107,    10,    11,    12,   342,
       0,    39,    62,   118,    68,    69,     7,     7,    74,    64,
      54,    62,    45,    79,    15,    53,    62,   360,   162,    79,
      59,    76,    84,    23,    75,    53,    54,    71,    63,    59,
      60,    84,     5,    79,     5,    99,    50,   137,     5,    12,
      68,    69,    70,    84,    53,    54,    89,    64,     5,    75,
      81,   168,     5,   361,    84,    21,    22,    23,    88,    89,
      90,    68,    69,    70,    77,    95,    79,    97,    98,   181,
      75,    75,     5,     5,     5,   105,   106,   107,   193,   123,
     195,     5,    64,    76,    64,   115,   124,   125,   118,    79,
     152,   130,    80,   137,   132,    79,   404,     6,   136,    76,
      79,     0,   410,   411,    64,    77,    65,    66,     7,    68,
      69,    70,    77,    77,    13,     5,    15,     5,    17,    18,
      19,   429,   152,   339,    23,    79,    82,   170,    76,   345,
      53,    54,    75,     7,    79,    77,    75,    78,   168,    75,
     170,   305,    65,    66,    81,    68,    69,    70,     5,   188,
       5,   181,    80,   183,   271,   272,    76,    74,    80,    80,
      59,    60,   341,   193,    78,   195,    78,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,    79,
      78,    15,    79,    76,   214,     5,    81,     7,    82,     9,
      89,    11,    12,    13,    14,    62,    95,    17,    97,    98,
      43,    76,    79,   247,   242,    76,   105,   106,   107,   252,
      79,    24,    80,    77,   378,    80,   115,    49,    50,    82,
      76,   251,   252,    42,   339,    62,    76,   257,    80,    78,
     345,    51,   294,    65,    66,   335,    68,    69,    70,    21,
      64,   271,   272,    63,    80,    75,    62,    80,    68,    80,
      78,    80,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,    79,   328,   305,    75,   168,
      75,   170,    20,    49,    50,    20,   338,    53,    54,   341,
      78,    75,   181,    75,    85,    80,     0,   387,   388,    65,
      66,   335,    68,    69,    70,    80,     0,     0,   328,   361,
     103,   373,     3,     4,     5,     6,   257,     8,   338,   339,
     334,   341,   113,   193,   303,   345,   117,    18,   338,   364,
     338,   122,   338,   125,   293,   126,   127,   128,   129,   130,
     131,   361,    33,    34,   364,    36,   328,   340,   197,   377,
     378,    -1,   404,   387,   388,    -1,   345,    -1,   410,   411,
      -1,    -1,   382,   252,    -1,    -1,    -1,    -1,   257,    -1,
     161,   423,    -1,    -1,    -1,    66,    -1,   429,    -1,    -1,
      -1,    -1,   271,   272,   404,    -1,    -1,    -1,    79,    -1,
     410,   411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     191,    -1,    -1,   194,    -1,    -1,    -1,    -1,    -1,   429,
      -1,    -1,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     221,    -1,    -1,    -1,    -1,   226,   227,   228,   229,   328,
      -1,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,    -1,   243,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,    24,
      25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    -1,    40,    41,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   295,    -1,    51,    -1,    53,    54,
      -1,    -1,   303,   304,    -1,    -1,    -1,    -1,    63,    -1,
      -1,    66,    -1,    68,    -1,    -1,    -1,    72,    -1,    -1,
      -1,    -1,    77,    78,    79,   326,    81,     7,    83,     9,
      -1,    11,    -1,    13,    14,    -1,    -1,    17,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    17,    18,    19,
      -1,    -1,   363,    -1,    -1,    25,    26,    -1,    -1,    -1,
      -1,    51,   373,    33,    34,    -1,    36,    37,    38,    -1,
      40,    41,    -1,    63,    -1,    -1,    -1,    -1,    68,    -1,
      -1,    51,    -1,    53,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,   405,   406,    66,    -1,    68,    -1,
      -1,   412,    72,    -1,    -1,    -1,    -1,    77,    78,    79,
      -1,    81,    -1,    83,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    25,    26,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      -1,    40,    41,    -1,     3,     4,     5,     6,    -1,     8,
      -1,    -1,    51,    -1,    53,    54,    -1,    -1,    -1,    18,
      -1,    -1,    -1,    -1,    63,    -1,    -1,    66,    -1,    68,
      -1,    -1,    -1,    72,    33,    34,    -1,    36,    77,    -1,
      79,    -1,    81,    -1,    83,     3,     4,     5,     6,     7,
       8,     9,    -1,    11,    12,    13,    14,    -1,    -1,    17,
      18,    -1,    -1,    -1,    -1,    -1,    -1,    66,     3,     4,
       5,     6,    -1,     8,    -1,    33,    34,    -1,    36,    -1,
      79,    -1,    81,    18,    83,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    51,    -1,    53,    54,    -1,    33,    34,
      -1,    36,    -1,    -1,    -1,    63,    -1,    -1,    66,    -1,
      68,    -1,    -1,    -1,    72,    -1,    -1,    -1,    53,    54,
      -1,    79,    -1,    81,    -1,    83,     5,    -1,     7,    -1,
       9,    66,    11,    -1,    13,    14,    -1,    72,    17,    -1,
       3,     4,     5,     6,    79,     8,    81,    82,     3,     4,
       5,     6,     7,     8,     9,    18,    11,    -1,    13,    14,
      -1,    -1,    17,    18,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    51,    36,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    -1,    63,    -1,    -1,    -1,    -1,    68,
      53,    54,    -1,    -1,    -1,    -1,    51,    -1,    53,    54,
      79,    -1,    -1,    66,    83,    -1,    -1,    -1,    63,    72,
      -1,    66,    -1,    68,    77,    -1,    79,    72,    81,     5,
      -1,     7,    77,     9,    79,    11,    81,    13,    14,    -1,
      16,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,    35,
      -1,    -1,    -1,    39,     3,     4,     5,     6,    44,     8,
      -1,    -1,     5,    12,     7,    51,     9,    -1,    11,    18,
      13,    14,    -1,    -1,    17,    -1,    -1,    63,    -1,    -1,
      -1,    -1,    68,    -1,    33,    34,    -1,    36,    -1,    75,
      -1,    -1,    -1,    79,    -1,    -1,    -1,    83,     3,     4,
       5,     6,    -1,     8,    53,    54,    -1,    -1,    51,    -1,
       5,    -1,     7,    18,     9,    -1,    11,    66,    13,    14,
      63,    -1,    17,    72,    -1,    68,    -1,    -1,    33,    34,
      79,    36,    81,     5,    -1,     7,    79,     9,    -1,    11,
      83,    13,    14,    -1,    -1,    17,    -1,    -1,    53,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,
      -1,    66,    -1,    -1,    -1,    -1,    -1,    72,    63,    -1,
      -1,    -1,    -1,    68,    79,    -1,    81,    -1,    -1,    51,
      -1,     5,    -1,     7,    79,     9,    -1,    11,    83,    13,
      14,    63,    -1,    17,    -1,    -1,    68,    47,    48,    49,
      50,    -1,    -1,    53,    54,    -1,    -1,    79,    -1,    81,
      60,    61,    62,    63,    64,    65,    66,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    47,    48,    49,    50,    63,
      -1,    53,    54,    -1,    68,    -1,    -1,    -1,    60,    61,
      62,    63,    64,    65,    66,    79,    68,    69,    70,    47,
      48,    49,    50,    -1,    76,    53,    54,    -1,    -1,    -1,
      82,    -1,    60,    61,    62,    63,    64,    65,    66,    -1,
      68,    69,    70,    47,    48,    49,    50,    -1,    -1,    53,
      54,    -1,    80,    -1,    -1,    -1,    60,    61,    62,    63,
      64,    65,    66,    -1,    68,    69,    70,    47,    48,    49,
      50,    -1,    -1,    53,    54,    -1,    80,    -1,    -1,    -1,
      60,    61,    62,    63,    64,    65,    66,    -1,    68,    69,
      70,    47,    48,    49,    50,    -1,    -1,    53,    54,    -1,
      80,    -1,    -1,    -1,    60,    61,    62,    63,    64,    65,
      66,    -1,    68,    69,    70,    47,    48,    49,    50,    -1,
      -1,    53,    54,    -1,    80,    -1,    -1,    -1,    60,    61,
      62,    63,    64,    65,    66,    -1,    68,    69,    70,    47,
      48,    49,    50,    -1,    -1,    53,    54,    -1,    80,    -1,
      -1,    -1,    60,    61,    62,    63,    64,    65,    66,    -1,
      68,    69,    70,    -1,    47,    48,    49,    50,    -1,    77,
      53,    54,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,
      63,    64,    65,    66,    -1,    68,    69,    70,    47,    48,
      49,    50,    -1,    76,    53,    54,    -1,    -1,    -1,    -1,
      -1,    60,    61,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    47,    48,    49,    50,    -1,    76,    53,    54,
      -1,    -1,    -1,    -1,    -1,    60,    61,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    47,    48,    49,    50,
      -1,    -1,    53,    54,    47,    48,    49,    50,    -1,    -1,
      -1,    -1,    63,    64,    65,    66,    -1,    68,    69,    70,
      63,    64,    65,    66,    -1,    68,    69,    70
};
#define YYPURE 1

/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/misc/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/misc/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 1:
#line 161 "parser.y"
{ yyval = nil; decls = yyval; ;
    break;}
case 2:
#line 162 "parser.y"
{ yyval = CONS(yyvsp[-1], yyvsp[0]); decls = yyval; ;
    break;}
case 3:
#line 166 "parser.y"
{ yyval = LOCATED(yyvsp[0]); ;
    break;}
case 13:
#line 186 "parser.y"
{ yyval = U(DummyDecl, NULL); ;
    break;}
case 14:
#line 190 "parser.y"
{ yyval = U(TopLevelOpen, yyvsp[0]); ;
    break;}
case 15:
#line 194 "parser.y"
{ yyval = U(GlobalDecl, yyvsp[-1]); ;
    break;}
case 16:
#line 198 "parser.y"
{ yyval = U(ExceptionDecl, yyvsp[0]); ;
    break;}
case 17:
#line 202 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 18:
#line 203 "parser.y"
{ yyval = gont_strjoin(yyvsp[-1], yyvsp[0]); ;
    break;}
case 19:
#line 207 "parser.y"
{ yyval = empty_string; ;
    break;}
case 20:
#line 208 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 21:
#line 213 "parser.y"
{ yyval = make_fn_decl(yyvsp[-2], yyvsp[-1], yyvsp[0]); ;
    break;}
case 22:
#line 219 "parser.y"
{ yyval = U(SectionDecl, P(yyvsp[-1], make_section_record(yyvsp[0]))); ;
    break;}
case 23:
#line 225 "parser.y"
{ yyval = U(ExternC, yyvsp[-1]); ;
    break;}
case 24:
#line 226 "parser.y"
{ yyval = U(ExternC, yyvsp[-1]); ;
    break;}
case 25:
#line 231 "parser.y"
{ yyval = LOCATED(make_lambda_assign(yyvsp[-1], yyvsp[0])); ;
    break;}
case 26:
#line 238 "parser.y"
{ yyval = U(SimpleName, yyvsp[0]); ;
    break;}
case 28:
#line 243 "parser.y"
{ yyval = U(QualifiedName, P(yyvsp[-2], yyvsp[0])); ;
    break;}
case 29:
#line 247 "parser.y"
{ yyval = make_vardef(yyvsp[-1], yyvsp[0]); ;
    break;}
case 30:
#line 255 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 31:
#line 256 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]) ;
    break;}
case 32:
#line 260 "parser.y"
{ yyval = nil; ;
    break;}
case 33:
#line 261 "parser.y"
{ yyval = nil; ;
    break;}
case 34:
#line 262 "parser.y"
{ yyval = yyvsp[-1]; ;
    break;}
case 35:
#line 266 "parser.y"
{ yyval = nil; ;
    break;}
case 36:
#line 267 "parser.y"
{ yyval = nil; ;
    break;}
case 37:
#line 271 "parser.y"
{ yyval = make_field(yyvsp[-2], yyvsp[-1]); ;
    break;}
case 38:
#line 275 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 39:
#line 276 "parser.y"
{ yyval = CONS(yyvsp[-1], yyvsp[0]); ;
    break;}
case 40:
#line 281 "parser.y"
{ yyval = make_tydef(yyvsp[-3], yyvsp[-4], U(Struct, yyvsp[-1])); ;
    break;}
case 41:
#line 283 "parser.y"
{ yyval = make_tydef(yyvsp[-3], yyvsp[-4], U(OptStruct, yyvsp[-1])); ;
    break;}
case 42:
#line 285 "parser.y"
{ yyval = make_tydef(yyvsp[-3], yyvsp[-4], U(Union, yyvsp[-1])); ;
    break;}
case 43:
#line 287 "parser.y"
{ yyval = make_tydef(yyvsp[0], yyvsp[-1], yyvsp[-2]); ;
    break;}
case 44:
#line 289 "parser.y"
{ yyval = make_tydef(yyvsp[0], yyvsp[-1], U(AbstractType, NULL)); ;
    break;}
case 45:
#line 293 "parser.y"
{ yyval = U(Void, NULL); ;
    break;}
case 46:
#line 294 "parser.y"
{ yyval = U(Int, NULL); ;
    break;}
case 47:
#line 295 "parser.y"
{ yyval = U(Bool, NULL); ;
    break;}
case 48:
#line 296 "parser.y"
{ yyval = U(Float, NULL); ;
    break;}
case 49:
#line 297 "parser.y"
{ yyval = U(String, NULL); ;
    break;}
case 50:
#line 302 "parser.y"
{ yyval = bare_fn_type(yyvsp[-3], yyvsp[-1]); ;
    break;}
case 51:
#line 304 "parser.y"
{ yyval = bare_fn_type(yyvsp[-4], yyvsp[-2]); ;
    break;}
case 52:
#line 308 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 53:
#line 312 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 54:
#line 313 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 55:
#line 317 "parser.y"
{ yyval = nil; ;
    break;}
case 56:
#line 318 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 57:
#line 322 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 58:
#line 323 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 59:
#line 324 "parser.y"
{ yyval = make_tyvar(yyvsp[0]); ;
    break;}
case 60:
#line 325 "parser.y"
{ yyval = make_named_type(yyvsp[0], yyvsp[-2]); ;
    break;}
case 61:
#line 328 "parser.y"
{ yyval = make_named_type(yyvsp[0], CONS(make_named_type(yyvsp[-2], yyvsp[-4]), nil)); ;
    break;}
case 62:
#line 330 "parser.y"
{ yyval = make_named_type(yyvsp[0], CONS(make_named_type(yyvsp[-4], yyvsp[-6]), yyvsp[-2])); ;
    break;}
case 63:
#line 331 "parser.y"
{ yyval = U(Tuple, yyvsp[-1]); ;
    break;}
case 64:
#line 335 "parser.y"
{ yyval = yyvsp[-1]; ;
    break;}
case 65:
#line 336 "parser.y"
{ yyval = make_named_type(yyvsp[0], nil); ;
    break;}
case 66:
#line 337 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 67:
#line 345 "parser.y"
{ yyval = P(yyvsp[0], none); ;
    break;}
case 68:
#line 346 "parser.y"
{ yyval = P(yyvsp[-1], Some(yyvsp[0])); ;
    break;}
case 69:
#line 347 "parser.y"
{ yyval = P(WEAK(), none); ;
    break;}
case 70:
#line 348 "parser.y"
{ yyval = P(WEAK(), Some(yyvsp[0])); ;
    break;}
case 71:
#line 352 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 72:
#line 353 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 73:
#line 357 "parser.y"
{ yyval = nil; ;
    break;}
case 74:
#line 358 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 75:
#line 363 "parser.y"
{ yyval = make_vardef(bare_fn_type(yyvsp[-4], yyvsp[-1]), yyvsp[-3]); ;
    break;}
case 76:
#line 365 "parser.y"
{ yyval = make_vardef(bare_fn_type(WEAK(), yyvsp[-1]), yyvsp[-3]); ;
    break;}
case 77:
#line 369 "parser.y"
{ yyval = U(FuncProto, yyvsp[-1]); ;
    break;}
case 78:
#line 370 "parser.y"
{ yyval = U(XCFuncProto, P(yyvsp[-1], yyvsp[-3])); ;
    break;}
case 79:
#line 375 "parser.y"
{ yyval = P(WEAK(), Some(yyvsp[0])); ;
    break;}
case 80:
#line 376 "parser.y"
{ yyval = P(WEAK(), none); ;
    break;}
case 81:
#line 380 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 82:
#line 381 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 83:
#line 385 "parser.y"
{ yyval = nil; ;
    break;}
case 84:
#line 386 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 85:
#line 393 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 86:
#line 394 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 87:
#line 398 "parser.y"
{ yyval = nil; ;
    break;}
case 88:
#line 399 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 89:
#line 403 "parser.y"
{ yyval = EXPR(Ref, make_ref_record(yyvsp[0])); ;
    break;}
case 90:
#line 407 "parser.y"
{ yyval = CONS(yyvsp[-2], CONS(yyvsp[0], nil)); ;
    break;}
case 91:
#line 408 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 92:
#line 412 "parser.y"
{ yyval = EXPR(TupleExpr, yyvsp[-1]); ;
    break;}
case 93:
#line 417 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 94:
#line 418 "parser.y"
{ yyval = BIN(Assign, yyvsp[-2], yyvsp[0]); ;
    break;}
case 95:
#line 419 "parser.y"
{ yyval = UNARY(PreDec, yyvsp[0]); ;
    break;}
case 96:
#line 420 "parser.y"
{ yyval = UNARY(PreInc, yyvsp[0]); ;
    break;}
case 97:
#line 421 "parser.y"
{ yyval = UNARY(PostDec, yyvsp[-1]); ;
    break;}
case 98:
#line 422 "parser.y"
{ yyval = UNARY(PostInc, yyvsp[-1]); ;
    break;}
case 99:
#line 426 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 100:
#line 427 "parser.y"
{ yyval = BIN(Plus, yyvsp[-2], yyvsp[0]); ;
    break;}
case 101:
#line 428 "parser.y"
{ yyval = BIN(Minus, yyvsp[-2], yyvsp[0]); ;
    break;}
case 102:
#line 429 "parser.y"
{ yyval = BIN(Mult, yyvsp[-2], yyvsp[0]); ;
    break;}
case 103:
#line 430 "parser.y"
{ yyval = BIN(Div, yyvsp[-2], yyvsp[0]); ;
    break;}
case 104:
#line 431 "parser.y"
{ yyval = BIN(Mod, yyvsp[-2], yyvsp[0]); ;
    break;}
case 105:
#line 432 "parser.y"
{ yyval = BIN(Lt, yyvsp[-2], yyvsp[0]); ;
    break;}
case 106:
#line 433 "parser.y"
{ yyval = BIN(Gt, yyvsp[-2], yyvsp[0]); ;
    break;}
case 107:
#line 434 "parser.y"
{ yyval = BIN(Ge, yyvsp[-2], yyvsp[0]); ;
    break;}
case 108:
#line 435 "parser.y"
{ yyval = BIN(Le, yyvsp[-2], yyvsp[0]); ;
    break;}
case 109:
#line 436 "parser.y"
{ yyval = BIN(Eq, yyvsp[-2], yyvsp[0]); ;
    break;}
case 110:
#line 437 "parser.y"
{ yyval = BIN(Ne, yyvsp[-2], yyvsp[0]); ;
    break;}
case 111:
#line 438 "parser.y"
{ yyval = UNARY(Negate, yyvsp[0]); ;
    break;}
case 112:
#line 444 "parser.y"
{ yyval = EXPR(UnionExpr, make_namedexpr(yyvsp[-2], EXPR(VoidConst, NULL))); ;
    break;}
case 113:
#line 446 "parser.y"
{ yyval = EXPR(UnionExpr, make_namedexpr(yyvsp[-3], yyvsp[-1])); ;
    break;}
case 114:
#line 448 "parser.y"
{ yyval = EXPR(UnionExpr, make_namedexpr(yyvsp[-1], yyvsp[0])); ;
    break;}
case 115:
#line 452 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 116:
#line 455 "parser.y"
{ yyval = BIN(Eq, yyvsp[0], 
					   EXPR(BoolConst, (void*)0)); ;
    break;}
case 117:
#line 457 "parser.y"
{ yyval = BIN(Plus, yyvsp[-2], yyvsp[0]); ;
    break;}
case 118:
#line 458 "parser.y"
{ yyval = BIN(Minus, yyvsp[-2], yyvsp[0]); ;
    break;}
case 119:
#line 459 "parser.y"
{ yyval = BIN(Mult, yyvsp[-2], yyvsp[0]); ;
    break;}
case 120:
#line 460 "parser.y"
{ yyval = BIN(Div, yyvsp[-2], yyvsp[0]); ;
    break;}
case 121:
#line 461 "parser.y"
{ yyval = BIN(Mod, yyvsp[-2], yyvsp[0]); ;
    break;}
case 122:
#line 462 "parser.y"
{ yyval = BIN(Lt, yyvsp[-2], yyvsp[0]); ;
    break;}
case 123:
#line 463 "parser.y"
{ yyval = BIN(Gt, yyvsp[-2], yyvsp[0]); ;
    break;}
case 124:
#line 464 "parser.y"
{ yyval = BIN(Ge, yyvsp[-2], yyvsp[0]); ;
    break;}
case 125:
#line 465 "parser.y"
{ yyval = BIN(Le, yyvsp[-2], yyvsp[0]); ;
    break;}
case 126:
#line 466 "parser.y"
{ yyval = BIN(Eq, yyvsp[-2], yyvsp[0]); ;
    break;}
case 127:
#line 467 "parser.y"
{ yyval = BIN(Ne, yyvsp[-2], yyvsp[0]); ;
    break;}
case 128:
#line 468 "parser.y"
{ yyval = BIN(AndIf, yyvsp[-2], yyvsp[0]); ;
    break;}
case 129:
#line 469 "parser.y"
{ yyval = BIN(OrIf, yyvsp[-2], yyvsp[0]); ;
    break;}
case 130:
#line 470 "parser.y"
{ yyval = UNARY(Negate, yyvsp[0]); ;
    break;}
case 131:
#line 471 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 132:
#line 472 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 133:
#line 473 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 134:
#line 474 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 135:
#line 479 "parser.y"
{ yyval = make_int_const(yyvsp[0], make_location(&yyloc)) ;
    break;}
case 136:
#line 481 "parser.y"
{ yyval = make_float_const(yyvsp[0], make_location(&yyloc)) ;
    break;}
case 137:
#line 483 "parser.y"
{ yyval = make_char_const((gont_ptroff)yyvsp[0], make_location(&yyloc)) ;
    break;}
case 138:
#line 484 "parser.y"
{ yyval = EXPR(StringConst, yyvsp[0]); ;
    break;}
case 139:
#line 485 "parser.y"
{ yyval = EXPR(BoolConst, (void*)1); ;
    break;}
case 140:
#line 486 "parser.y"
{ yyval = EXPR(BoolConst, (void*)0); ;
    break;}
case 141:
#line 487 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 142:
#line 488 "parser.y"
{ yyval = yyvsp[-1]; ;
    break;}
case 143:
#line 489 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 144:
#line 490 "parser.y"
{ yyval = EXPR(NullConst, NULL); ;
    break;}
case 145:
#line 492 "parser.y"
{ yyval = EXPR(DotExpr, make_sini_expr(yyvsp[0], yyvsp[-2])); ;
    break;}
case 146:
#line 497 "parser.y"
{ yyval = make_sini_expr(yyvsp[-2], yyvsp[0]); ;
    break;}
case 147:
#line 501 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 148:
#line 502 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 149:
#line 507 "parser.y"
{ yyval = EXPR(StructExpr, yyvsp[-2]) ;
    break;}
case 150:
#line 512 "parser.y"
{ yyval = EXPR(Call, P(yyvsp[-3], yyvsp[-1])); ;
    break;}
case 151:
#line 517 "parser.y"
{ yyval = LOCATED(make_lambda(bare_fn_type(yyvsp[-4], yyvsp[-2]), yyvsp[0])); ;
    break;}
case 152:
#line 519 "parser.y"
{ yyval = LOCATED(make_lambda(bare_fn_type(WEAK(), yyvsp[-2]), yyvsp[0])); ;
    break;}
case 153:
#line 521 "parser.y"
{ yyval = LOCATED(make_lambda(bare_fn_type(WEAK(), yyvsp[-2]), yyvsp[0])); ;
    break;}
case 154:
#line 528 "parser.y"
{ yyval = STMT(Block, yyvsp[-1]); ;
    break;}
case 155:
#line 532 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 156:
#line 533 "parser.y"
{ yyval = CONS(yyvsp[-1], yyvsp[0]); ;
    break;}
case 157:
#line 537 "parser.y"
{ yyval = nil; ;
    break;}
case 158:
#line 538 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 169:
#line 555 "parser.y"
{ yyval = STMT(If, gont_make_tuple(3, yyvsp[-2], yyvsp[0], SKIP())); ;
    break;}
case 170:
#line 560 "parser.y"
{ yyval = STMT(If, gont_make_tuple(3, yyvsp[-4], yyvsp[-2], yyvsp[0])); ;
    break;}
case 171:
#line 562 "parser.y"
{ yyval = STMT(If, gont_make_tuple(3, yyvsp[-4], yyvsp[-2], yyvsp[0])); ;
    break;}
case 172:
#line 566 "parser.y"
{ yyval = P(yyvsp[0], SKIP()); ;
    break;}
case 173:
#line 568 "parser.y"
{ yyval = P(yyvsp[-2], STMT(Expr, BIN(Assign,
				    EXPR(Ref, make_ref_record(yyvsp[-2])),
				    yyvsp[0]))); ;
    break;}
case 174:
#line 575 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 175:
#line 576 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 176:
#line 580 "parser.y"
{ yyval = make_vardefs(yyvsp[-1], yyvsp[0]); ;
    break;}
case 177:
#line 581 "parser.y"
{ yyval = make_vardefs(WEAK(), yyvsp[0]); ;
    break;}
case 178:
#line 586 "parser.y"
{ yyval = STMT(Expr, yyvsp[0]); ;
    break;}
case 179:
#line 587 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 180:
#line 588 "parser.y"
{ yyval = SKIP(); ;
    break;}
case 181:
#line 590 "parser.y"
{ yyval = make_located(U(Skip, NULL), &last_lex_loc); ;
    break;}
case 182:
#line 594 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 183:
#line 596 "parser.y"
{ yyval = make_expr(U(BoolConst, (void*)1), &last_lex_loc); ;
    break;}
case 184:
#line 600 "parser.y"
{ yyval = STMT(Expr, yyvsp[0]) ;
    break;}
case 185:
#line 601 "parser.y"
{ yyval = SKIP(); ;
    break;}
case 186:
#line 603 "parser.y"
{ yyval = make_located(U(Skip, NULL), &last_lex_loc); ;
    break;}
case 187:
#line 607 "parser.y"
{ yyval = empty_string; ;
    break;}
case 188:
#line 608 "parser.y"
{ yyval = yyvsp[-1]; ;
    break;}
case 189:
#line 612 "parser.y"
{ yyval = U(SimpleName, empty_string); ;
    break;}
case 190:
#line 613 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 191:
#line 618 "parser.y"
{ yyval = LOOP(yyvsp[-5],
		     PAIR(STMT(BreakIfNot, yyvsp[-2]), yyvsp[0]),
		     SKIP()); ;
    break;}
case 192:
#line 622 "parser.y"
{ yyval = LOOP(yyvsp[-7],
		      PAIR(yyvsp[-5], STMT(BreakIfNot, yyvsp[-2])),
		      SKIP()); ;
    break;}
case 193:
#line 629 "parser.y"
{ yyval = STMT(Block, CONS(yyvsp[-6],
				  CONS(LOOP(yyvsp[-9],
					    PAIR(STMT(BreakIfNot, yyvsp[-4]), yyvsp[0]),
					    yyvsp[-2]),
				       nil))); ;
    break;}
case 194:
#line 637 "parser.y"
{ yyval = STMT(Expr, yyvsp[0]); ;
    break;}
case 195:
#line 638 "parser.y"
{ yyval = STMT(Return, EXPR(VoidConst, NULL)); ;
    break;}
case 196:
#line 639 "parser.y"
{ yyval = STMT(Return, yyvsp[0]); ;
    break;}
case 197:
#line 640 "parser.y"
{ yyval = SKIP(); ;
    break;}
case 198:
#line 641 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 199:
#line 642 "parser.y"
{ yyval = STMT(Raise, yyvsp[0]); ;
    break;}
case 200:
#line 644 "parser.y"
{ yyval = LOCATED(make_break(U(BreakKind, NULL), yyvsp[0])); ;
    break;}
case 201:
#line 646 "parser.y"
{ yyval = LOCATED(make_break(U(ContinueKind, NULL), yyvsp[0])); ;
    break;}
case 202:
#line 650 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 203:
#line 651 "parser.y"
{ yyval = STMT(Block, CONS(STMT(Return, yyvsp[-1]), nil)); ;
    break;}
case 204:
#line 660 "parser.y"
{ yyval = P(yyvsp[-1], EXPR(BoolConst, (void*)1)); ;
    break;}
case 205:
#line 662 "parser.y"
{ yyval = P(yyvsp[-3], yyvsp[-1]); ;
    break;}
case 206:
#line 666 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 207:
#line 667 "parser.y"
{ yyval = CONS(yyvsp[-1], yyvsp[0]); ;
    break;}
case 208:
#line 671 "parser.y"
{ yyval = make_case_clause(yyvsp[-1], STMT(Block, yyvsp[0])); ;
    break;}
case 209:
#line 675 "parser.y"
{ yyval = CONS(yyvsp[-1], yyvsp[0]); ;
    break;}
case 210:
#line 676 "parser.y"
{ yyval = nil; ;
    break;}
case 211:
#line 680 "parser.y"
{ yyval = P(yyvsp[-2], yyvsp[0]); ;
    break;}
case 212:
#line 684 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 213:
#line 685 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 214:
#line 689 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 215:
#line 690 "parser.y"
{ yyval = SKIP(); ;
    break;}
case 216:
#line 694 "parser.y"
{ yyval = yyvsp[-1]; ;
    break;}
case 217:
#line 695 "parser.y"
{ yyval = nil; ;
    break;}
case 218:
#line 700 "parser.y"
{ yyval = STMT(Try, make_try_record(yyvsp[-2], yyvsp[-1], yyvsp[0])); ;
    break;}
case 219:
#line 705 "parser.y"
{ yyval = STMT(Let, P(yyvsp[-2], yyvsp[0])); ;
    break;}
case 220:
#line 707 "parser.y"
{ yyval = STMT(Switch, P(yyvsp[-3], yyvsp[-1])); ;
    break;}
case 221:
#line 715 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 222:
#line 716 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 223:
#line 720 "parser.y"
{ yyval = nil; ;
    break;}
case 224:
#line 721 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 225:
#line 725 "parser.y"
{ yyval = U(TuplePattern, yyvsp[-1]); ;
    break;}
case 226:
#line 729 "parser.y"
{ yyval = LOCATED(yyvsp[0]); ;
    break;}
case 227:
#line 733 "parser.y"
{ yyval = U(VoidPattern, NULL); ;
    break;}
case 228:
#line 734 "parser.y"
{ yyval = U(ExprPattern, yyvsp[0]); ;
    break;}
case 229:
#line 735 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 230:
#line 737 "parser.y"
{ yyval = U(UnionPattern, make_named_pattern(yyvsp[-1], yyvsp[0])); ;
    break;}
case 231:
#line 741 "parser.y"
{ yyval = LOCATED(yyvsp[0]); ;
    break;}
}

#line 705 "/usr/share/misc/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 744 "parser.y"


struct gont_union *parse(struct gont_string *file)
{
	void *lex = make_lexer(file->data);

	/* yydebug = 1; */

	if (none == NULL) {
		none = gont_make_union(GontUF_Std__None, NULL);
		nil = gont_make_union(GontUF_List__Nil, NULL);
		empty_string = gont_make_string(0, NULL);
	}

	input_filename = gont_make_string(file->len, file->data);

	if (yyparse(lex)) {
		/* We should never get here... */
		yyerror("parse error");
	}

	return decls;
}
